///
/// Copyright (c) 2019, BAS Services & Graphics, LLC.
/// Licensed under the Academic Free License version 3.0
///

library haystack.hnull;

import 'HVal.dart';

/// HNull is the singleton value used to indicate value is null (for example, for initial value).
///
/// @see <a href='http://project-haystack.org/doc/TagModel#tagKinds'>Project Haystack</a>
///
class HNull extends HVal {
  /// Singleton value
  static final HNull _VAL = new HNull._();

  factory HNull() => _VAL;

  HNull._();

  /// Hash code
  ///
  /// No need to override `==`, we need default identical
  /// function.
  @override
  int get hashCode => 0xb5eb;

  /// Encodes as "Null"
  @override
  String toString() => "Null";

  /// Encodes as "null"
  @override
  String toJson() => "null";

  /// Encodes as "N"
  @override
  String toZinc() => "N";
}
