///
/// Copyright (c) 2019, BAS Services & Graphics, LLC.
/// Licensed under the Academic Free License version 3.0
///

library haystack.hval;

import 'package:meta/meta.dart';

/// HVal is the base class for representing haystack tag
/// scalar values as an immutable class.
///
/// See [Project Haystack](http://project-haystack.org/doc/TagModel#tagKinds)
@immutable
abstract class HVal {

  /// Hash code is value based.
  @override
  int get hashCode;


  /// Returns sort order as negative, 0, or positive.
  int compareTo(Object that) {
    return toString().compareTo(that.toString());
  }

  /// String format is for human consumption only.
  @override
  String toString() => toZinc();

  /// Encodes value to zinc format.
  String toZinc();

  /// Encodes to JSON string value.
  String toJson();
}
