///
/// Copyright (c) 2015, BAS Services & Graphics, LLC.
/// Licensed under the Academic Free License version 3.0
///

/// CallException base class for exceptions thrown HClient.call.
/// Subclasses:
/// <ul>
/// <li>CallNetworkException: network communication error</li>
/// <li>CallHttpException: HTTP response error such as 404</li>
/// <li>CallErrException: server errors with server side stack trace</li>
/// <li>CallAuthException: authentication error</li>
/// <ul>
class CallError extends Error {
  final String msg;

  CallError(this.msg);
}
