///
/// Copyright (c) 2015, BAS Services & Graphics, LLC.
/// Licensed under the Academic Free License version 3.0
///

library haystack.str_utils;

import 'package:unicode/unicode.dart';

const int BS_CHAR = 8; // '\b'
const int TAB_CHAR = 9; // tab
const int NL_CHAR = 10; // new line
const int FF_CHAR = 12; // '\f'
const int CR_CHAR = 13; // carriage return

const int SPACE_CHAR = 32; // ' '
const int EXCLAMATION_CHAR = 33; // !
const int DOUBLE_QUOTE_CHAR = 34; // "
const int NUMBER_SIGN_CHAR = 35; // '#'
const int DOLLAR_CHAR = 36; // '$'
const int PERCENT_CHAR = 37; // '%'
const int AMPERSAND_CHAR = 38; // '&'
const int QUOTE_CHAR = 39; // *
const int OPEN_PARENTHESE_CHAR = 40; // '('
const int CLOSE_PARENTHESE_CHAR = 41; // ')'
const int ASTERISK_CHAR = 41; // *
const int PLUS_CHAR = 43; // '+'
const int COMMA_CHAR = 44; // ','
const int MINUS_CHAR = 45; // '-'
const int PERIOD_CHAR = 46; // '.'
const int SLASH_CHAR = 47; // '/'
const int ZERO_CHAR = 48;

const int NINE_CHAR = 57;
const int COLON_CHAR = 58; // ':'
const int SEMICOLON_CHAR = 59; // ';'
const int LESS_CHAR = 60; // <
const int EQUALS_SIGN_CHAR = 61; // '='
const int GREATER_CHAR = 62; // >
const int QUESTION_MARK_CHAR = 63; // '?'
const int DOG_CHAR = 64; // '@'

const int A_CHAR = 65;
const int E_CHAR = 69;
const int F_CHAR = 70;
const int I_CHAR = 73;
const int T_CHAR = 84;
const int Z_CHAR = 90;

const int OPEN_BRACKET_CHAR = 91; // '['
const int BACKSLASH_CHAR = 92; // '\\'
const int CLOSE_BRACKET_CHAR = 93; // ']'
const int UNDERSCORE_CHAR = 95; // '_'
const int BACKQUOTE_CHAR = 96; // '`'

const int a_CHAR = 97;
const int b_CHAR = 98;
const int e_CHAR = 101;
const int f_CHAR = 102;
const int n_CHAR = 110;
const int r_CHAR = 114;
const int t_CHAR = 116;
const int u_CHAR = 117;
const int x_CHAR = 0x78;
const int z_CHAR = 122;

const int OPEN_BRACE_CHAR = 123; // '{'
const int CLOSE_BRACE_CHAR = 125; // '}'
const int TILDE_CHAR = 126; // '~'

bool isLetter(int char) =>
    isLowercaseLetter(char) ||
    isModifierLetter(char) ||
    isOtherLetter(char) ||
    isTitlecaseLetter(char) ||
    isUppercaseLetter(char);
