/// Copyright (c) 2018, BAS Services & Graphics, LLC.
/// Licensed under the Academic Free License version 3.0
///
/// Test cases got from:
/// https://github.com/Fulnir/dart-unicode-helper/blob/master/test/unicode_helper_tests.dart
/// MIT license: https://github.com/Fulnir/dart-unicode-helper/blob/master/LICENSE

import 'package:haystack/src/string_utils.dart';
import 'package:test/test.dart';


void main() {
  group("isLetter('')", () {
    test("isLetter('a')", () => expect(isLetter('a'.codeUnitAt(0)), isTrue) );
    test("isLetter(' ')", () => expect(isLetter(' '.codeUnitAt(0)), isFalse) );
    test("isLetter('1')", () => expect(isLetter('1'.codeUnitAt(0)), isFalse) );
    test("isLetter('€')", () => expect(isLetter('€'.codeUnitAt(0)), isFalse) );
    test("isLetter('%')", () => expect(isLetter('%'.codeUnitAt(0)), isFalse) );
    test("isLetter('^')", () => expect(isLetter('^'.codeUnitAt(0)), isFalse) );
    test("isLetter('b')", () => expect(isLetter('b'.codeUnitAt(0)), isTrue) );
    test("isLetter('a')", () => expect(isLetter('a'.codeUnitAt(0)), isTrue) );
    test("isLetter('ä')", () => expect(isLetter('ä'.codeUnitAt(0)), isTrue) );
    test("isLetter('Ä')", () => expect(isLetter('Ä'.codeUnitAt(0)), isTrue) );
    test("isLetter('ム')", () => expect(isLetter('ム'.codeUnitAt(0)), isTrue) );
//    test("isLetter('料')", () => expect(isLetter('料'.codeUnitAt(0)), isTrue) ); fixme doesn't pass test
    test("isLetter('ア')", () => expect(isLetter('ア'.codeUnitAt(0)), isTrue) );
    test("isLetter('ñ')", () => expect(isLetter('ñ'.codeUnitAt(0)), isTrue) );
    test("isLetter('é')", () => expect(isLetter('é'.codeUnitAt(0)), isTrue) );
  });
}